<%-- $Id: edit_plugin.jsp 6621 2014-11-24 13:15:23Z nicklas $
	------------------------------------------------------------------
	Copyright (C) 2005 Nicklas Nordborg
	Copyright (C) 2006 Jari Häkkinen, Nicklas Nordborg, Martin Svensson
	Copyright (C) 2007 Johan Enell, Nicklas Nordborg

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------


	@author Nicklas
	@version 2.0
--%>
<%@ page pageEncoding="UTF-8" session="false"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.Item"
	import="net.sf.basedb.core.ItemContext"
	import="net.sf.basedb.core.Include"
	import="net.sf.basedb.core.Permission"
	import="net.sf.basedb.core.PluginDefinition"
	import="net.sf.basedb.core.ItemQuery"
	import="net.sf.basedb.core.ItemResultList"
	import="net.sf.basedb.core.JobAgent"
	import="net.sf.basedb.core.JobAgentSettings"
	import="net.sf.basedb.core.BaseException"
	import="net.sf.basedb.core.PermissionDeniedException"
	import="net.sf.basedb.core.RoleKey"
	import="net.sf.basedb.core.SystemItems"
	import="net.sf.basedb.core.plugin.Plugin"
	import="net.sf.basedb.core.plugin.Permissions"
	import="net.sf.basedb.core.query.Restrictions"
	import="net.sf.basedb.core.query.Orders"
	import="net.sf.basedb.core.query.Hql"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.clients.web.util.HTML"
	import="net.sf.basedb.clients.web.PermissionUtil"
	import="net.sf.basedb.util.Values"
	import="net.sf.basedb.core.plugin.GuiContext"
	import="net.sf.basedb.clients.web.extensions.ExtensionsControl"
	import="net.sf.basedb.clients.web.extensions.JspContext"
	import="net.sf.basedb.clients.web.extensions.edit.EditUtil"
	import="net.sf.basedb.util.extensions.ExtensionsInvoker"
	import="net.sf.basedb.util.json.NameableConverter"
	import="org.json.simple.JSONArray"
	import="org.json.simple.JSONObject"
	import="java.util.EnumSet"
	import="java.util.Set"
	import="java.util.Map"
	import="java.util.List"
	import="java.util.Collection"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%@ taglib prefix="t" uri="/WEB-INF/tab.tld" %>
<%@ taglib prefix="ext" uri="/WEB-INF/extensions.tld" %>
<%!
private static final int DENY_CODE = PermissionUtil.getPermissionCode(EnumSet.of(Permission.DENIED));
private static final int CREATE_CODE = PermissionUtil.getPermissionCode(EnumSet.of(Permission.CREATE));
private static final int READ_CODE = PermissionUtil.getPermissionCode(EnumSet.of(Permission.READ));
private static final int USE_CODE = PermissionUtil.getPermissionCode(EnumSet.of(Permission.USE));
private static final int WRITE_CODE = PermissionUtil.getPermissionCode(EnumSet.of(Permission.WRITE));
private static final int DELETE_CODE = PermissionUtil.getPermissionCode(EnumSet.of(Permission.DELETE));
private static final int SET_OWNER_CODE = PermissionUtil.getPermissionCode(EnumSet.of(Permission.SET_OWNER));
private static final int SET_PERMISSION_CODE = PermissionUtil.getPermissionCode(EnumSet.of(Permission.SET_PERMISSION));

private String getOption(DbControl dc, PluginDefinition plugin, Item itemType)
	throws BaseException
{
	int keyId = SystemItems.getRoleKeyId(itemType);
	if (keyId == 0) return "";

	RoleKey key = RoleKey.getById(dc, keyId);	
	StringBuilder sb = new StringBuilder();
	sb.append("<option value=\"").append(key.getItemType().name()).append("\">");
	sb.append(HTML.encodeTags(key.getName()));
	sb.append(" []");
	return sb.toString();
}
private void appendPermissionLetter(StringBuilder sb, Permission p, String letter, 
	Set<Permission> defined, Set<Permission> always, Set<Permission> maybe)
{
	if (defined != null && defined.contains(p))
	{
		if (always != null && always.contains(p))
		{
			sb.append(letter.toUpperCase());
		}
		else if (maybe != null && maybe.contains(p))
		{
			sb.append(letter.toLowerCase());
		}
		else
		{
			sb.append("-");
		}
	}
}
%>
<%
final Item itemType = Item.PLUGINDEFINITION;
final SessionControl sc = Base.getExistingSessionControl(pageContext, true);
final ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, null, null);
final int itemId = cc.getId();
final String ID = sc.getId();
final float scale = Base.getScale(sc);
final DbControl dc = sc.newDbControl();
try
{
	String title = null;
	PluginDefinition plugin = null;
	boolean isTrusted = true;
	Boolean allowImmediateExecution = null;
	boolean usePermissions = false;
	Collection<Permissions> requestedPermissions = null;
	String warning = null;
	
	final int selectedAgentId = Values.getInt(request.getParameter("jobagent_id"), -1);

	// Query to retrieve job agents
	ItemQuery<JobAgent> agentQuery = null;

	// Query to retrieve role keys
	final ItemQuery<RoleKey> roleKeyQuery = RoleKey.getQuery();
	roleKeyQuery.order(Orders.asc(Hql.property("name")));
	
	if (itemId == 0)
	{
		title = "Create plugin";
		cc.removeObject("item");
		String tt = cc.getPropertyValue("trusted");
		String up = cc.getPropertyValue("usePermissions");
		String aie = cc.getPropertyValue("allowImmediateExection");
		isTrusted = tt == null ? isTrusted : Values.getBoolean(tt);
		usePermissions = up == null ? usePermissions : Values.getBoolean(up);
		allowImmediateExecution = aie == null ? null : Values.getBoolean(aie);
	}
	else
	{
		plugin = PluginDefinition.getById(dc, itemId);
		plugin.checkPermission(Permission.WRITE);
		cc.setObject("item", plugin);
		title = "Edit plugin -- " + HTML.encodeTags(plugin.getName());
		isTrusted = plugin.isTrusted();
		usePermissions = plugin.getUsePermissions();
		allowImmediateExecution = plugin.getAllowImmediateExecution();

		agentQuery = JobAgent.getQuery();
		agentQuery.include(Include.ALL);
		agentQuery.order(Orders.asc(Hql.property("name")));
		agentQuery.join(Hql.innerJoin("plugins", "p"));
		agentQuery.restrict(Restrictions.eq(Hql.property("p", "pluginDefinition"), Hql.entity(plugin)));

		try
		{
			Plugin thePlugin = plugin.newInstance(Plugin.class, sc, null, null);
			requestedPermissions = thePlugin.getPermissions();
		}
		catch (BaseException ex)
		{
			warning = ex.getMessage();
		}
	}
	
	// Load job agent settings as JSON objects
	JSONArray jsonSettings = new JSONArray();
	JSONObject jsonAgents = new JSONObject();
	jsonAgents.put("itemType", "JOBAGENT");
	if (agentQuery != null)
	{
		JSONArray jsonLinked = new JSONArray();
		NameableConverter converter = new NameableConverter();
		for (JobAgent agent : agentQuery.list(dc))
		{
			JobAgentSettings settings = agent.getSettings(plugin, false);
			Boolean trusted = null;
			Long maxMemory = null;
			int priorityBoost = 0;
			if (settings != null)
			{
				trusted = settings.isTrusted();
				maxMemory = settings.getMaxMemory();
				priorityBoost = settings.getPriorityBoost();
				jsonLinked.add(converter.convert(agent));
				
			}
			JSONObject jsonSetting = new JSONObject();
			jsonSetting.put("agentId", agent.getId());
			if (trusted != null) 
			{
				jsonSetting.put("trusted", trusted ? 1 : 0);
			}
			else
			{
				jsonSetting.put("trusted", "");
			}
			if (maxMemory != null)
			{
				jsonSetting.put("maxMemory", Values.formatBytes(maxMemory));
			}
			jsonSetting.put("priorityBoost", priorityBoost);
			jsonSettings.add(jsonSetting);
		}	
		jsonAgents.put("items", jsonLinked);
	}

	// Convert permissions requested by the plugin to a JSON object
	JSONArray jsonRequestedPermissions = new JSONArray();
	if (requestedPermissions != null)
	{
		for (Permissions pp : requestedPermissions)
		{
			Item ppType = pp.getItemType();
			if (ppType.getDefinedPermissions() != null)
			{
				Set<Permission> always = Permission.expand(pp.getAlwaysGranted());
				Set<Permission> maybe = Permission.expand(pp.getMaybeGranted());
				JSONObject jsonRequested = new JSONObject();
				jsonRequested.put("itemType", ppType.name());
				jsonRequested.put("granted", always == null ? 0 : PermissionUtil.getPermissionCode(always));
				jsonRequested.put("denied", maybe == null ? 255 : 255 & ~PermissionUtil.getPermissionCode(maybe));
				jsonRequestedPermissions.add(jsonRequested);
			}
		}
	}
	
	JspContext jspContext = ExtensionsControl.createContext(dc, pageContext, GuiContext.item(itemType), plugin);
	ExtensionsInvoker invoker = EditUtil.useEditExtensions(jspContext);
	%>
	<base:page type="popup" title="<%=title%>" id="edit-page">
	<base:head scripts="tabcontrol-2.js,linkitems-2.js,~plugins.js" styles="tabcontrol.css">
		<ext:scripts context="<%=jspContext%>" />
		<ext:stylesheets context="<%=jspContext%>" />
	</base:head>
	<base:body>
		<h1><%=title%> <base:help tabcontrol="settings" /></h1>
		<form action="index.jsp?ID=<%=ID%>" method="post" name="plugin">
		<input type="hidden" name="cmd" value="UpdateItem">

		<div id="page-data" class="datacontainer"
			data-agent-settings="<%=HTML.encodeTags(jsonSettings.toJSONString()) %>"
			data-select-agent="<%=selectedAgentId%>"
			data-create="<%=CREATE_CODE%>"
			data-read="<%=READ_CODE%>"
			data-use="<%=USE_CODE%>"
			data-write="<%=WRITE_CODE%>"
			data-delete="<%=DELETE_CODE%>"
			data-set-owner="<%=SET_OWNER_CODE%>"
			data-set-permission="<%=SET_PERMISSION_CODE%>"
			data-requested-permissions="<%=HTML.encodeTags(jsonRequestedPermissions.toJSONString())%>"
			></div>

		<t:tabcontrol id="settings" 
			subclass="content dialogtabcontrol" 
			position="bottom" remember="<%=plugin != null%>" 
			active="<%=selectedAgentId == -1 ? null : "agents" %>"
			extensions="<%=invoker%>">
		<t:tab id="info" title="Plugin" helpid="plugindefinition.edit">
			<table class="fullform input100">
			<tr>
				<th>Name</th>
				<td><%=HTML.encodeTags(plugin == null ? Values.getString(cc.getPropertyValue("name"), "New plugin") : plugin.getName())%></td>
				<td></td>
			</tr>
			<tr>
				<th>Class</th>
				<td><input class="text required auto-init" 
					data-auto-init="<%=plugin == null ? "focus-select" : "focus" %>" 
					type="text" name="className" 
					value="<%=HTML.encodeTags(plugin == null ? cc.getPropertyValue("className") : plugin.getClassName())%>" 
					maxlength="<%=PluginDefinition.MAX_CLASSNAME_LENGTH%>"></td>
				<td></td>
			</tr>
			
			<tr>
				<th>JAR file</th>
				<td><input class="text" type="text" name="jarFile" 
					value="<%=HTML.encodeTags(plugin == null ? cc.getPropertyValue("jarFile") : plugin.getJarFile())%>"
					maxlength="<%=PluginDefinition.MAX_JARFILE_LENGTH%>">
				</td>
				<td></td>
			</tr>
			<tr>
				<th>Max memory</th>
				<td><input class="text" type="text" name="maxMemory" style="width: 15em;"
					value="<%=Values.formatBytes(plugin == null ? Values.parseBytes(cc.getPropertyValue("maxMemory"), null) : plugin.getMaxMemory())%>"
					maxlength="16"> (Use KB, MB or GB to specify units)</td>
				<td></td>
			</tr>
			<tr>
				<th>Trusted</th>
				<td>
					<input type="radio" name="trusted" id="trustedNo" value="0" 
						<%=!isTrusted ? "checked" : ""%>><label for="trustedNo">no</label>
					<input type="radio" name="trusted" id="trustedYes" value="1" 
						<%=isTrusted ? "checked" : ""%>><label for="trustedYes">yes</label>
				</td>
				<td></td>
			</tr>	
			<tr>
				<th>Allow immediate<br>exection</th>
				<td>
					<input type="radio" name="allow_immediate_execution" id="immediateNo" value="0" 
						<%=Boolean.FALSE.equals(allowImmediateExecution) ? "checked" : ""%>><label for="immediateNo">no</label>
					<input type="radio" name="allow_immediate_execution" id="immediateYes" value="1" 
						<%=Boolean.TRUE.equals(allowImmediateExecution) ? "checked" : ""%>><label for="immediateYes">yes</label>
					<%
					if (allowImmediateExecution == null)
					{
						%>
						<input type="radio" name="allow_immediate_execution" id="immediateAuto" value="" 
							checked><label for="immediateAuto">auto</label>
						<%
					}
					%>
				</td>
				<td></td>
			</tr>
			<tr class="dynamic">
				<th></th>
				<td>
					<%
					if (warning != null) 
					{
						%>
						<div class="messagecontainer error"><%=warning%></div>
						<%
					}
					%>
				</td>
				<td></td>
			</tr>
			</table>
		</t:tab>
		
		<t:tab id="permissions" title="Permissions" 
			tooltip="Set permissions for this plugindefintion" helpid="plugindefinition.edit.permissions">
			<table class="fullform input100">
				<tr>	
					<th>Use permissions</th>
					<td>
						<input type="radio" name="use_permissions" id="permissionsYes" value="1" 
							<%=usePermissions ? "checked" : ""%>><label for="permissionsYes">yes</label>
						<input type="radio" name="use_permissions" id="permissionsNo" value="0" 
							<%=!usePermissions ? "checked" : ""%>><label for="permissionsNo">no</label>
						<%
						if (plugin == null)
						{
							%>
							<input type="radio" name="use_permissions" id="permissionsAuto" value="2" 
								><label for="permissionsAuto">if requested by plugin</label>
							<%
						}
						%>
					</td>
				</tr>
				<tr class="dynamic">
					<th>Item types</th>
					<td>
						<div class="selectionlist">
							<table>
							<tr>
							<td>
								<select name="itemTypes" size="20" id="itemTypes" multiple>
								<%
								Map<String, List<Item>> permissionGroups = PermissionUtil.getPermissionGroups();
								for (Map.Entry<String, List<Item>> entry : permissionGroups.entrySet())
								{
									String name = entry.getKey();
									List<Item> items = entry.getValue();
									%>
									<option class="selectoptionheader" value="">-- <%=name%>
									<%
									for (Item item : items)
									{
										%>
										<%=getOption(dc, plugin, item)%>
										<%
									}
								}
								%>
								</select>
								<b>Capital letters</b> = Permission is always granted<br>
								<b>Small letters</b> = Permission is only granted if logged in user 
									has that permission
							</td>
							<td style="vertical-align: top;">
								<table style="width: 20em;">
								<tr>
								<td>
									<b>Always grant</b><br>
									<input type="checkbox" name="grant_create" id="grant_create"><label for="grant_create">Create</label><br>
									<input type="checkbox" name="grant_read" id="grant_read"><label for="grant_read">Read</label><br>
									<input type="checkbox" name="grant_use" id="grant_use"><label for="grant_use">Use</label><br>
									<input type="checkbox" name="grant_write" id="grant_write"><label for="grant_write">Write</label><br>
									<input type="checkbox" name="grant_delete" id="grant_delete"><label for="grant_delete">Delete</label><br>
									<input type="checkbox" name="grant_set_owner" id="grant_set_owner"><label for="grant_set_owner">Set owner</label><br>
									<input type="checkbox" name="grant_set_permission" id="grant_set_permission"><label for="grant_set_permission">Set permission</label>
								</td>
								<td>
									<b>Always deny</b><br>
									<input type="checkbox" name="deny_create" id="deny_create"><label for="deny_create">Create</label><br>
									<input type="checkbox" name="deny_read" id="deny_read"><label for="deny_read">Read</label><br>
									<input type="checkbox" name="deny_use" id="deny_use"><label for="deny_use">Use</label><br>
									<input type="checkbox" name="deny_write" id="deny_write"><label for="deny_write">Write</label><br>
									<input type="checkbox" name="deny_delete" id="deny_delete"><label for="deny_delete">Delete</label><br>
									<input type="checkbox" name="deny_set_owner" id="deny_set_owner"><label for="deny_set_owner">Set owner</label><br>
									<input type="checkbox" name="deny_set_permission" id="deny_set_permission"><label for="deny_set_permission">Set permission</label>
								</td>
								</tr>
								<tr>
								<td colspan="2">
									<div class="messagecontainer help" style="margin: 0.5em 0px 0px 0px; height: 12em; overflow: auto;">
										<b>Requested by plugin</b><br>
										<%
										if (requestedPermissions != null && requestedPermissions.size() > 0)
										{
											%>
											<table>
											<%
											for (Permissions pp : requestedPermissions)
											{
												Item ppType = pp.getItemType();
												Set<Permission> always = Permission.expand(pp.getAlwaysGranted());
												Set<Permission> maybe = Permission.expand(pp.getMaybeGranted());
												Set<Permission> defined = ppType.getDefinedPermissions();
												if (defined != null)
												{
													StringBuilder sb = new StringBuilder();
													sb.append("[");
													appendPermissionLetter(sb, Permission.CREATE, "C", defined, always, maybe);
													appendPermissionLetter(sb, Permission.READ, "R", defined, always, maybe);
													appendPermissionLetter(sb, Permission.USE, "U", defined, always, maybe);
													appendPermissionLetter(sb, Permission.WRITE, "W", defined, always, maybe);
													appendPermissionLetter(sb, Permission.DELETE, "D", defined, always, maybe);
													appendPermissionLetter(sb, Permission.SET_OWNER, "O", defined, always, maybe);
													appendPermissionLetter(sb, Permission.SET_PERMISSION, "P", defined, always, maybe);
													sb.append("]");
													%>
													<tr>
														<td><%=ppType%>&nbsp;</td>
														<td><%=sb.toString()%></td>
													</tr>
													<%
												}
											}
											%>
											</table>
											<%
										}
										else
										{
											%>
											This plug-in doesn't request any permissions.
											<%
										}
										%>
										</div>
										<base:buttongroup>
											<base:button title="Use requested permissions" id="btnSetRequestedPermissions"
												tooltip="Use the permissions requested by the plugin." 
												visible="<%=requestedPermissions != null && requestedPermissions.size() > 0%>"/>
										</base:buttongroup>
									</td>
								</tr>
								</table>
							</td>
						</tr>
						</table>
					</div>
				</td>
			</tr>
			</table>
		</t:tab>
		<t:tab id="agents" title="Job agents" helpid="plugindefinition.jobagents">
			<table class="fullform input100">
			<tr>
				<th><label for="use_internal_jobqueue">Use internal job queue</label></th>
				<td>
					<input type="checkbox" name="use_internal_jobqueue" id="use_internal_jobqueue" value="1"
						<%=plugin == null || plugin.getUseInternalJobQueue() ? "checked" : "" %>>
				</td>
			</tr>
			<tr class="big">
				<th>Job agents</th>
				<td>
					<div class="selectionlist">
						<table>
						<tr>
							<td>
								<select name="agents" id="agents"
									class="auto-init" data-auto-init="link-container"
									data-initial-items="[<%=HTML.encodeTags(jsonAgents.toJSONString()) %>]"
									size="12" multiple>
								</select>
							</td>
							<td style="vertical-align: top;">
								<base:buttongroup vertical="true">
									<base:button 
										id="btnAddAgents"
										subclass="leftaligned auto-init"
										data-auto-init="add-link"
										data-list-id="agents"
										data-item-type="JOBAGENT"
										title="Add&nbsp;job&nbsp;agents&hellip;"  
										tooltip="Add job agents to this plugin"
									/>
									<base:button 
										id="btnRemoveAgents"
										subclass="leftaligned auto-init"
										data-auto-init="remove-link"
										data-list-id="agents"
										style="width: 14em;"
										title="Remove" 
										tooltip="Remove the selected job agents"
									/>
								</base:buttongroup>
							</td>
						</tr>
						</table>
					</div>
				</td>
			</tr>
			<tbody class="sectionheader">
				<tr class="sectionheader">
					<th colspan="2">Settings for the selected job agent</th>
				</tr>
			</tbody>
			<tbody id="agentsettings" style="display: none;">
				<tr>
					<th class="subprompt">Max memory</th>
					<td>
						<input type="text" name="agentMaxMemory" id="agentMaxMemory" class="text" style="width: 15em;"
							maxlength="16">
							(Use KB, MB or GB to specify memory)
					</td>
				</tr>
				<tr>
					<th class="subprompt"></th>
					<td>
						<input type="checkbox" name="useDefaultMaxMemory" id="useDefaultMaxMemory">
						<label for="useDefaultMaxMemory">Use default</label> (<span id="defaultMaxMemory"></span>)
					</td>
				</tr>
				<tr>
					<th class="subprompt">Trusted</th>
					<td>
						<input type="radio" name="agentTrusted" id="agentTrustedDefault" value="" 
							><label for="agentTrustedDefault">default (<span id="defaultTrusted"></span>)</label>
						<input type="radio" name="agentTrusted" id="agentTrustedYes" value="1"
							><label for="agentTrustedYes">yes</label>
						<input type="radio" name="agentTrusted" id="agentTrustedNo" value="0"
							><label for="agentTrustedNo">no</label>
					</td>
				</tr>
				<tr>
					<th class="subprompt">Priority boost</th>
					<td>
						<input type="text" name="agentPriorityBoost" id="agentPriorityBoost" 
							class="text" style="width: 15em;"
							maxlength="10">
					</td>
				</tr>
			</tbody>
			<tr class="dynamic">
				<th></th>
				<td></td>
			</tr>
			</table>
		</t:tab>
		
		<t:tab id="annotations" title="Annotations" 
			helpid="annotations.edit" tooltip="Enter values for annotations"
			visible="<%=plugin != null && !plugin.requiresConfiguration() && plugin.supports("net.sf.basedb.core.plugin.AnnotationSetterPlugin")%>"
			>
			<jsp:include page="../../common/annotations/annotate_frameset.jsp">
				<jsp:param name="item_type" value="<%=itemType.name()%>" />
				<jsp:param name="item_id" value="<%=itemId%>" />
				<jsp:param name="ID" value="<%=ID%>" />
			</jsp:include>			
		</t:tab>		
		</t:tabcontrol>
		<%
		ItemResultList<RoleKey> roleKeys = roleKeyQuery.list(dc);
		for (RoleKey key : roleKeys)
		{
			int grantedCode = plugin == null ? 0 : PermissionUtil.getPermissionCode(plugin.getGranted(key));
			int deniedCode = plugin == null ? 255 : PermissionUtil.getPermissionCode(plugin.getDenied(key));
			int definedCode = key.getItemType().getDefinedPermissions() == null ? 0 : PermissionUtil.getPermissionCode(key.getItemType().getDefinedPermissions());			
			String name = key.getItemType().name();						
			%>
			<input type="hidden" name="<%=name%>_granted" value="<%=grantedCode%>">
			<input type="hidden" name="<%=name%>_denied" value="<%=deniedCode%>">
			<input type="hidden" name="<%=name%>_defined" value="<%=definedCode%>">
			<%
		}
		%>
		</form>
		
		<div class="legend">
			<base:icon image="required.png" />= required information
		</div>

		<base:buttongroup subclass="dialogbuttons">
			<base:button id="btnSave" title="Save" />
			<base:button id="close" title="Cancel" />
		</base:buttongroup>
		
	</base:body>
	</base:page>
	<%
}
finally
{
	if (dc != null) dc.close();
}
%>
