/* $Id $
	------------------------------------------------------------------
	Copyright (C) 2012 Nicklas Nordborg

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------

	@author Nicklas
*/

var Configure = function()
{
	var configure = {};
	
	/**
		Initialize the page.
	*/
	configure.initPage = function()
	{
		// Buttons
		Buttons.addClickHandler('close', App.closeWindow);
		Buttons.addClickHandler('btnSave', Configure.save);
		
		// The 'unlimited' checkboxes
		Events.addEventHandler('unlimited.upload', 'click', Configure.unlimitedTransferRateOnClick);
		Events.addEventHandler('unlimited.download', 'click', Configure.unlimitedTransferRateOnClick);
	}
	
	/**
		Event handler for the 'unlimited' transfer rate checkboxes.
		Depending on the status of the checkbox it will enable
		or disable the associated free input field.
	 */
	configure.unlimitedTransferRateOnClick = function(event)
	{
		var frm = document.forms['server'];
		var checkbox = event.currentTarget;
		var transferRate = frm[Data.get(checkbox, 'rate-field')];
		if (checkbox.checked)
		{
			Doc.addClass(transferRate, 'disabled');
			transferRate.disabled = true;
			transferRate.oldValue = transferRate.value;
			transferRate.value = 'unlimited';
			
		}
		else
		{
			Doc.removeClass(transferRate, 'disabled');
			transferRate.disabled = false;
			transferRate.value = transferRate.oldValue ? transferRate.oldValue : '';
			transferRate.focus();
		}
	}
	
	// Save the configuration settings
	configure.save = function()
	{
		var frm = document.forms['server'];
		if (TabControl.validateActiveTab('settings'))
		{
			frm.submit();
		}
	}

	return configure;
}();

Doc.onLoad(Configure.initPage);